Package org.wildfly.plugin.dev

## Class DevMojo

- java.lang.Object
- - org.apache.maven.plugin.AbstractMojo
  - - org.wildfly.plugin.common.AbstractServerConnection
    - - org.wildfly.plugin.server.AbstractStartMojo
      - - org.wildfly.plugin.server.AbstractServerStartMojo
        - - org.wildfly.plugin.dev.DevMojo

- All Implemented Interfaces:
    `org.apache.maven.plugin.ContextEnabled`, `org.apache.maven.plugin.Mojo`

      @Mojo(name="dev",
            requiresDependencyResolution=COMPILE_PLUS_RUNTIME,
            defaultPhase=PACKAGE)
      public class DevMojo
      extends AbstractServerStartMojo

  Starts a standalone instance of WildFly and deploys the application to the server. The deployment type must be a WAR. Once the server is running, the source directories are monitored for changes. If required the sources will be compiled and the deployment may be redeployed.

  Note that changes to the POM file are not monitored. If changes are made the POM file, the process will need to be terminated and restarted.

  Note that if a WildFly Bootable JAR is packaged, it is ignored by this goal.

  Since:
    4.1
  Author:
    James R. Perkins

- - ### Field Summary

    - ### Fields inherited from class org.wildfly.plugin.server.AbstractServerStartMojo

      `jbossHome, moduleOptions, targetDir`

    - ### Fields inherited from class org.wildfly.plugin.server.AbstractStartMojo

      `debug, debugHost, debugPort, debugSuspend, javaHome, javaOpts, mavenRepoManager, mavenSession, project, propertiesFile, repositories, repoSystem, serverArgs, serverManager, session, skip`

    - ### Fields inherited from class org.wildfly.plugin.common.AbstractServerConnection

      `DEBUG_MESSAGE_NO_CREDS, DEBUG_MESSAGE_NO_ID, DEBUG_MESSAGE_NO_SERVER_SECTION, DEBUG_MESSAGE_NO_SETTINGS_FILE, DEBUG_MESSAGE_POM_HAS_CREDS, DEBUG_MESSAGE_SETTINGS_HAS_CREDS, DEBUG_MESSAGE_SETTINGS_HAS_ID, timeout`

    - ### Fields inherited from interface org.apache.maven.plugin.Mojo

      `ROLE`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DevMojo()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected org.wildfly.core.launcher.CommandBuilder` | `createCommandBuilder​(Path jbossHome)` |
    `protected org.jboss.galleon.universe.maven.repo.MavenRepoManager` | `createMavenRepoManager()` |
    `void` | `execute()` |
    `String` | `goal()` | The goal of the deployment.
    `protected Path` | `provisionIfRequired​(Path installDir)` |
    `void` | `setIgnorePatterns​(String ignorePatterns)` | Allows the ignorePatterns to be set as a string.
    `void` | `setWebExtensions​(String webExtensions)` | Allows the webExtensions to be set as a string.

    - ### Methods inherited from class org.wildfly.plugin.server.AbstractServerStartMojo

      `createDomainCommandBuilder, createStandaloneCommandBuilder, getDefaultFeaturePackLocation, getServerHome, setModulesOptions`

    - ### Methods inherited from class org.wildfly.plugin.server.AbstractStartMojo

      `actOnServerState, getManagementHostName, getManagementPort, init, setJavaOpts, standardOutput, startServer`

    - ### Methods inherited from class org.wildfly.plugin.common.AbstractServerConnection

      `createClient, getClientConfiguration`

    - ### Methods inherited from class org.apache.maven.plugin.AbstractMojo

      `getLog, getPluginContext, setLog, setPluginContext`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DevMojo

          public DevMojo()

  - ### Method Detail

    - #### execute

          public void execute()
                       throws org.apache.maven.plugin.MojoExecutionException,
                              org.apache.maven.plugin.MojoFailureException

      Throws:
        `org.apache.maven.plugin.MojoExecutionException`
        `org.apache.maven.plugin.MojoFailureException`

    - #### goal

          public String goal()

      Description copied from class: `AbstractServerConnection`
      The goal of the deployment.
      Specified by:
        `goal` in class `AbstractServerConnection`
      Returns:
        the goal of the deployment.

    - #### createMavenRepoManager

          protected org.jboss.galleon.universe.maven.repo.MavenRepoManager createMavenRepoManager()
                                                                                           throws org.apache.maven.plugin.MojoExecutionException

      Overrides:
        `createMavenRepoManager` in class `AbstractStartMojo`
      Throws:
        `org.apache.maven.plugin.MojoExecutionException`

    - #### createCommandBuilder

          protected org.wildfly.core.launcher.CommandBuilder createCommandBuilder​(Path jbossHome)
                                                                           throws org.apache.maven.plugin.MojoExecutionException

      Specified by:
        `createCommandBuilder` in class `AbstractStartMojo`
      Throws:
        `org.apache.maven.plugin.MojoExecutionException`

    - #### setWebExtensions

          public void setWebExtensions​(String webExtensions)

      Allows the webExtensions to be set as a string.
      Parameters:
        `webExtensions` - a whitespace delimited string for the web file extensions

    - #### setIgnorePatterns

          public void setIgnorePatterns​(String ignorePatterns)

      Allows the ignorePatterns to be set as a string.
      Parameters:
        `ignorePatterns` - a whitespace delimited string for the file patterns

    - #### provisionIfRequired

          protected Path provisionIfRequired​(Path installDir)
                                      throws org.apache.maven.plugin.MojoFailureException,
                                             org.apache.maven.plugin.MojoExecutionException

      Overrides:
        `provisionIfRequired` in class `AbstractServerStartMojo`
      Throws:
        `org.apache.maven.plugin.MojoFailureException`
        `org.apache.maven.plugin.MojoExecutionException`